import sys
import os

def installSharedApp():

   libExists = 'false'
   procExists = 'false'
   machExists = 'false'
   nodeExists = 'false'
   cellExists = 'false'
   appExists = 'false'
   force = 'false'
   update = 'false'

   from sys import argv

   #Get command line arguments
   for i in range(0, len(argv)):
      if argv[i] == '-rInstallPath':
         ratPath = argv[i+1]
      elif argv[i] == '-appName':
         myApp = argv[i+1]
         appExists = 'true'
      elif argv[i] == '-library':
         libName = argv[i+1]
         libExists = 'true'
      elif argv[i] == '-force':
         force = 'true'
      elif argv[i] == '-process':
         processName = argv[i+1]
         procExists = 'true'
      elif argv[i] == '-machine':
         machineName = argv[i+1]
         machExists = 'true'
      elif argv[i] == '-node':
         nodeName = argv[i+1]
         nodeExists = 'true'
      elif argv[i] == '-cell':
         cellName = argv[i+1]
         cellExists = 'true'
      elif argv[i] == '-update':
         update = 'true'
      else:
	 continue

   #Set path names
   if appExists == 'false':
      myApp = 'RAM1WebApplication'

   #Set path names
   if procExists == 'false':
      processName = 'server1'

   if machExists == 'false' or nodeExists == 'false' or cellExists == 'false':
      serverid = AdminConfig.getid('/Server:'+processName+'/')
      pathNames = AdminConfig.getObjectName(serverid)
      cellString = pathNames[pathNames.find('cell='):]
      cellBlah = cellString.replace('cell=', '')
      cellName = cellBlah[0:cellBlah.find(',')]
      nodeString = pathNames[pathNames.find('node='):]
      nodeBlah = nodeString.replace('node=', '')
      nodeName = nodeBlah[0:nodeBlah.find(',')]
      wholePath = '/Cell:' + cellName + '/Node:' + nodeName + '/Server:' + processName + '/'
   else:
      wholePath = '/Cell:' + machineName + nodeName + cellName + '/Node:' + machineName + nodeName + '/Server:' + processName + '/'

   if update == 'false':
      cqPath = ratPath + '/ClearQuest'
      cqPath2 = ratPath + '/clearquest'
      cqJar = '/cqjni.jar'
      cqLinuxPath = cqPath + '/cqweb/lib'
      cqLinuxPath2 = cqPath2 + '/cqweb/lib'
      cqJarPath = ''

      if os.path.exists(cqPath + cqJar):
         cqJarPath = cqPath + cqJar
      if os.path.exists(cqPath2 + cqJar):
         cqJarPath = cqPath2 + cqJar
      elif os.path.exists(cqLinuxPath + cqJar):
         cqJarPath = cqLinuxPath + cqJar
      elif os.path.exists(cqLinuxPath2 + cqJar):
         cqJarPath = cqLinuxPath2 + cqJar
      else:
	 print
	 print cqJar + " was not found at " + cqPath + cqJar + " or " + cqLinuxPath + cqJar
	 print
	 sys.exit(1)
	
      comPath = ratPath + '/common'
      cqNative = cqPath2 + ';' + comPath

   deployName = '/Deployment:' + myApp + '/'

   #Check if the server exists
   serv = AdminConfig.getid(wholePath)
   print serv

   #Check if the library exists
   if libExists == 'false':
      libName = 'CQLib'

   libId = '/Library:' + libName + '/'
   library = AdminConfig.getid(libId)

   #Create the library if it doesn't exist or if forced
   if update == 'true' and library == '':
      print 'Update failed : The shared library ' + libName + ' does not exist.'
      sys.exit(0)   
   elif update == 'true':
      'Shared library ' + libName + ' found will attempt update.'
   elif library == '' or force == 'true':
      library = AdminConfig.create('Library', serv, [['name', libName], ['classPath', cqJarPath], ['nativePath',  cqNative], 
      ['description', 'The DLLs and JNI API to access ClearQuest']])
   else:
	print 'The shared library ' + libName + ' already exists and -force was not used.  We will use this shared library.'

   print library

   #Map the shared lib to my EAR
   deployment = AdminConfig.getid(deployName)
   print deployment
 
   appDeploy = AdminConfig.showAttribute(deployment, 'deployedObject')
   print appDeploy

   classLoad1 = AdminConfig.showAttribute(appDeploy, 'classloader')
   print classLoad1

   print AdminConfig.create('LibraryRef', classLoad1, [['libraryName', libName], ['sharedClassloader', 'true']])
   
   #Save the changes
   AdminConfig.save()

   print 'The shared library ' + libName + ' was successfully linked to ' + myApp

def printUsage():

   print 'RAM/CQ Setup Version 7.0.0.1 [09/05/2007]'
   print ''
   print 'Usage:'
   print '   ws_admin [ws_admin options]'
   print ''
   print '   REQUIRED PARAMETERS:'
   print '          -rInstallPath [rational path]' 
   print '          (This is required unless you use the -update flag)'
   print ''
   print '   OPTIONAL PARAMETERS:'
   print '          -appName [application name]'
   print '          -process [process name]'
   print '          -machine [machine name]'
   print '          -node [node name]'
   print '          -cell [cell name]'
   print '          -library [library name] (optional)'
   print '          -force (optional)'
   print '          -update (optional)'
   print ''
   print '    [rational path] is the path to the Rational installation directory'
   print '       Be sure to use the backslash (/) as the path separator. e.g.' 
   print "       'C:/Program Files/Rational'"
   print ''
   print '    [application name] may be provided to specify a different application name'
   print '       to link to (the default is RAM1WebApplication)'
   print ''
   print '    [process name] may be provided to specify the process you are connecting to'
   print '       (the default is server1)'
   print ''
   print '    [machine name], [node name], and [cell name] may be provided if'
   print '       you need to specify the server path your application is installed under'
   print '       e.g. Cell:machineNodeCell'
   print '       (you must provide all three)'
   print '       By default, these are automatically determined using the process name'
   print ''
   print '    [library name] may be included to use an existing CQ shared library'
   print ''
   print '    [-force] may be passed in to force creation of a new library and ignore'
   print '       any existing library'
   print ''
   print '    [-update] called during update, this option will assume the shared lib'
   print '       already exists and will only map it to your application'

#-----------------------------------------------------------------
# Main
#-----------------------------------------------------------------
if len(sys.argv) < 1 or (len(sys.argv) > 16):
   printUsage()
else:
   installSharedApp()
